<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBaseInvCountTypeInvCount ArrayType
 * @subpackage Arrays
 */
class ArrayOfBaseInvCountTypeInvCount extends AbstractStructArrayBase
{
    /**
     * The InvCount
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\InvCount[]
     */
    public $InvCount;
    /**
     * Constructor method for ArrayOfBaseInvCountTypeInvCount
     * @uses ArrayOfBaseInvCountTypeInvCount::setInvCount()
     * @param \StructType\InvCount[] $invCount
     */
    public function __construct(array $invCount = array())
    {
        $this
            ->setInvCount($invCount);
    }
    /**
     * Get InvCount value
     * @return \StructType\InvCount[]|null
     */
    public function getInvCount()
    {
        return $this->InvCount;
    }
    /**
     * This method is responsible for validating the values passed to the setInvCount method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInvCount method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInvCountForArrayConstraintsFromSetInvCount(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfBaseInvCountTypeInvCountInvCountItem) {
            // validation for constraint: itemType
            if (!$arrayOfBaseInvCountTypeInvCountInvCountItem instanceof \StructType\InvCount) {
                $invalidValues[] = is_object($arrayOfBaseInvCountTypeInvCountInvCountItem) ? get_class($arrayOfBaseInvCountTypeInvCountInvCountItem) : sprintf('%s(%s)', gettype($arrayOfBaseInvCountTypeInvCountInvCountItem), var_export($arrayOfBaseInvCountTypeInvCountInvCountItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InvCount property can only contain items of type \StructType\InvCount, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InvCount value
     * @throws \InvalidArgumentException
     * @param \StructType\InvCount[] $invCount
     * @return \ArrayType\ArrayOfBaseInvCountTypeInvCount
     */
    public function setInvCount(array $invCount = array())
    {
        // validation for constraint: array
        if ('' !== ($invCountArrayErrorMessage = self::validateInvCountForArrayConstraintsFromSetInvCount($invCount))) {
            throw new \InvalidArgumentException($invCountArrayErrorMessage, __LINE__);
        }
        $this->InvCount = $invCount;
        return $this;
    }
    /**
     * Add item to InvCount value
     * @throws \InvalidArgumentException
     * @param \StructType\InvCount $item
     * @return \ArrayType\ArrayOfBaseInvCountTypeInvCount
     */
    public function addToInvCount(\StructType\InvCount $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InvCount) {
            throw new \InvalidArgumentException(sprintf('The InvCount property can only contain items of type \StructType\InvCount, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InvCount[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\InvCount|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\InvCount|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\InvCount|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\InvCount|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\InvCount|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InvCount
     */
    public function getAttributeName()
    {
        return 'InvCount';
    }
}
