<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDOW_RulesType ArrayType
 * @subpackage Arrays
 */
class ArrayOfDOW_RulesType extends AbstractStructArrayBase
{
    /**
     * The DaysOfWeek
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\DOW_RulesType[]
     */
    public $DaysOfWeek;
    /**
     * Constructor method for ArrayOfDOW_RulesType
     * @uses ArrayOfDOW_RulesType::setDaysOfWeek()
     * @param \StructType\DOW_RulesType[] $daysOfWeek
     */
    public function __construct(array $daysOfWeek = array())
    {
        $this
            ->setDaysOfWeek($daysOfWeek);
    }
    /**
     * Get DaysOfWeek value
     * @return \StructType\DOW_RulesType[]|null
     */
    public function getDaysOfWeek()
    {
        return $this->DaysOfWeek;
    }
    /**
     * This method is responsible for validating the values passed to the setDaysOfWeek method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDaysOfWeek method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDaysOfWeekForArrayConstraintsFromSetDaysOfWeek(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDOW_RulesTypeDaysOfWeekItem) {
            // validation for constraint: itemType
            if (!$arrayOfDOW_RulesTypeDaysOfWeekItem instanceof \StructType\DOW_RulesType) {
                $invalidValues[] = is_object($arrayOfDOW_RulesTypeDaysOfWeekItem) ? get_class($arrayOfDOW_RulesTypeDaysOfWeekItem) : sprintf('%s(%s)', gettype($arrayOfDOW_RulesTypeDaysOfWeekItem), var_export($arrayOfDOW_RulesTypeDaysOfWeekItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DaysOfWeek property can only contain items of type \StructType\DOW_RulesType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DaysOfWeek value
     * @throws \InvalidArgumentException
     * @param \StructType\DOW_RulesType[] $daysOfWeek
     * @return \ArrayType\ArrayOfDOW_RulesType
     */
    public function setDaysOfWeek(array $daysOfWeek = array())
    {
        // validation for constraint: array
        if ('' !== ($daysOfWeekArrayErrorMessage = self::validateDaysOfWeekForArrayConstraintsFromSetDaysOfWeek($daysOfWeek))) {
            throw new \InvalidArgumentException($daysOfWeekArrayErrorMessage, __LINE__);
        }
        $this->DaysOfWeek = $daysOfWeek;
        return $this;
    }
    /**
     * Add item to DaysOfWeek value
     * @throws \InvalidArgumentException
     * @param \StructType\DOW_RulesType $item
     * @return \ArrayType\ArrayOfDOW_RulesType
     */
    public function addToDaysOfWeek(\StructType\DOW_RulesType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DOW_RulesType) {
            throw new \InvalidArgumentException(sprintf('The DaysOfWeek property can only contain items of type \StructType\DOW_RulesType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DaysOfWeek[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DOW_RulesType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DOW_RulesType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DOW_RulesType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DOW_RulesType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DOW_RulesType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DaysOfWeek
     */
    public function getAttributeName()
    {
        return 'DaysOfWeek';
    }
}
