<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfHotelInfoTypeLanguage ArrayType
 * @subpackage Arrays
 */
class ArrayOfHotelInfoTypeLanguage extends AbstractStructArrayBase
{
    /**
     * The Language
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Language[]
     */
    public $Language;
    /**
     * Constructor method for ArrayOfHotelInfoTypeLanguage
     * @uses ArrayOfHotelInfoTypeLanguage::setLanguage()
     * @param \StructType\Language[] $language
     */
    public function __construct(array $language = array())
    {
        $this
            ->setLanguage($language);
    }
    /**
     * Get Language value
     * @return \StructType\Language[]|null
     */
    public function getLanguage()
    {
        return $this->Language;
    }
    /**
     * This method is responsible for validating the values passed to the setLanguage method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLanguage method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLanguageForArrayConstraintsFromSetLanguage(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfHotelInfoTypeLanguageLanguageItem) {
            // validation for constraint: itemType
            if (!$arrayOfHotelInfoTypeLanguageLanguageItem instanceof \StructType\Language) {
                $invalidValues[] = is_object($arrayOfHotelInfoTypeLanguageLanguageItem) ? get_class($arrayOfHotelInfoTypeLanguageLanguageItem) : sprintf('%s(%s)', gettype($arrayOfHotelInfoTypeLanguageLanguageItem), var_export($arrayOfHotelInfoTypeLanguageLanguageItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Language property can only contain items of type \StructType\Language, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Language value
     * @throws \InvalidArgumentException
     * @param \StructType\Language[] $language
     * @return \ArrayType\ArrayOfHotelInfoTypeLanguage
     */
    public function setLanguage(array $language = array())
    {
        // validation for constraint: array
        if ('' !== ($languageArrayErrorMessage = self::validateLanguageForArrayConstraintsFromSetLanguage($language))) {
            throw new \InvalidArgumentException($languageArrayErrorMessage, __LINE__);
        }
        $this->Language = $language;
        return $this;
    }
    /**
     * Add item to Language value
     * @throws \InvalidArgumentException
     * @param \StructType\Language $item
     * @return \ArrayType\ArrayOfHotelInfoTypeLanguage
     */
    public function addToLanguage(\StructType\Language $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Language) {
            throw new \InvalidArgumentException(sprintf('The Language property can only contain items of type \StructType\Language, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Language[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Language|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Language|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Language|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Language|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Language|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Language
     */
    public function getAttributeName()
    {
        return 'Language';
    }
}
