<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOTA_CancelRQReason ArrayType
 * @subpackage Arrays
 */
class ArrayOfOTA_CancelRQReason extends AbstractStructArrayBase
{
    /**
     * The Reason
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Reason[]
     */
    public $Reason;
    /**
     * Constructor method for ArrayOfOTA_CancelRQReason
     * @uses ArrayOfOTA_CancelRQReason::setReason()
     * @param \StructType\Reason[] $reason
     */
    public function __construct(array $reason = array())
    {
        $this
            ->setReason($reason);
    }
    /**
     * Get Reason value
     * @return \StructType\Reason[]|null
     */
    public function getReason()
    {
        return $this->Reason;
    }
    /**
     * This method is responsible for validating the values passed to the setReason method
     * This method is willingly generated in order to preserve the one-line inline validation within the setReason method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateReasonForArrayConstraintsFromSetReason(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOTA_CancelRQReasonReasonItem) {
            // validation for constraint: itemType
            if (!$arrayOfOTA_CancelRQReasonReasonItem instanceof \StructType\Reason) {
                $invalidValues[] = is_object($arrayOfOTA_CancelRQReasonReasonItem) ? get_class($arrayOfOTA_CancelRQReasonReasonItem) : sprintf('%s(%s)', gettype($arrayOfOTA_CancelRQReasonReasonItem), var_export($arrayOfOTA_CancelRQReasonReasonItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Reason property can only contain items of type \StructType\Reason, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Reason value
     * @throws \InvalidArgumentException
     * @param \StructType\Reason[] $reason
     * @return \ArrayType\ArrayOfOTA_CancelRQReason
     */
    public function setReason(array $reason = array())
    {
        // validation for constraint: array
        if ('' !== ($reasonArrayErrorMessage = self::validateReasonForArrayConstraintsFromSetReason($reason))) {
            throw new \InvalidArgumentException($reasonArrayErrorMessage, __LINE__);
        }
        $this->Reason = $reason;
        return $this;
    }
    /**
     * Add item to Reason value
     * @throws \InvalidArgumentException
     * @param \StructType\Reason $item
     * @return \ArrayType\ArrayOfOTA_CancelRQReason
     */
    public function addToReason(\StructType\Reason $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Reason) {
            throw new \InvalidArgumentException(sprintf('The Reason property can only contain items of type \StructType\Reason, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Reason[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Reason|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Reason|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Reason|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Reason|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Reason|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Reason
     */
    public function getAttributeName()
    {
        return 'Reason';
    }
}
