<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOTA_HotelRatePlanRQRatePlan ArrayType
 * @subpackage Arrays
 */
class ArrayOfOTA_HotelRatePlanRQRatePlan extends AbstractStructArrayBase
{
    /**
     * The RatePlan
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\RatePlan[]
     */
    public $RatePlan;
    /**
     * Constructor method for ArrayOfOTA_HotelRatePlanRQRatePlan
     * @uses ArrayOfOTA_HotelRatePlanRQRatePlan::setRatePlan()
     * @param \StructType\RatePlan[] $ratePlan
     */
    public function __construct(array $ratePlan = array())
    {
        $this
            ->setRatePlan($ratePlan);
    }
    /**
     * Get RatePlan value
     * @return \StructType\RatePlan[]|null
     */
    public function getRatePlan()
    {
        return $this->RatePlan;
    }
    /**
     * This method is responsible for validating the values passed to the setRatePlan method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRatePlan method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRatePlanForArrayConstraintsFromSetRatePlan(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOTA_HotelRatePlanRQRatePlanRatePlanItem) {
            // validation for constraint: itemType
            if (!$arrayOfOTA_HotelRatePlanRQRatePlanRatePlanItem instanceof \StructType\RatePlan) {
                $invalidValues[] = is_object($arrayOfOTA_HotelRatePlanRQRatePlanRatePlanItem) ? get_class($arrayOfOTA_HotelRatePlanRQRatePlanRatePlanItem) : sprintf('%s(%s)', gettype($arrayOfOTA_HotelRatePlanRQRatePlanRatePlanItem), var_export($arrayOfOTA_HotelRatePlanRQRatePlanRatePlanItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RatePlan property can only contain items of type \StructType\RatePlan, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RatePlan value
     * @throws \InvalidArgumentException
     * @param \StructType\RatePlan[] $ratePlan
     * @return \ArrayType\ArrayOfOTA_HotelRatePlanRQRatePlan
     */
    public function setRatePlan(array $ratePlan = array())
    {
        // validation for constraint: array
        if ('' !== ($ratePlanArrayErrorMessage = self::validateRatePlanForArrayConstraintsFromSetRatePlan($ratePlan))) {
            throw new \InvalidArgumentException($ratePlanArrayErrorMessage, __LINE__);
        }
        $this->RatePlan = $ratePlan;
        return $this;
    }
    /**
     * Add item to RatePlan value
     * @throws \InvalidArgumentException
     * @param \StructType\RatePlan $item
     * @return \ArrayType\ArrayOfOTA_HotelRatePlanRQRatePlan
     */
    public function addToRatePlan(\StructType\RatePlan $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RatePlan) {
            throw new \InvalidArgumentException(sprintf('The RatePlan property can only contain items of type \StructType\RatePlan, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RatePlan[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RatePlan|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RatePlan|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RatePlan|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RatePlan|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RatePlan|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RatePlan
     */
    public function getAttributeName()
    {
        return 'RatePlan';
    }
}
