<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRateUploadTypeAdditionalGuestAmount ArrayType
 * @subpackage Arrays
 */
class ArrayOfRateUploadTypeAdditionalGuestAmount extends AbstractStructArrayBase
{
    /**
     * The AdditionalGuestAmount
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\AdditionalGuestAmount[]
     */
    public $AdditionalGuestAmount;
    /**
     * Constructor method for ArrayOfRateUploadTypeAdditionalGuestAmount
     * @uses ArrayOfRateUploadTypeAdditionalGuestAmount::setAdditionalGuestAmount()
     * @param \StructType\AdditionalGuestAmount[] $additionalGuestAmount
     */
    public function __construct(array $additionalGuestAmount = array())
    {
        $this
            ->setAdditionalGuestAmount($additionalGuestAmount);
    }
    /**
     * Get AdditionalGuestAmount value
     * @return \StructType\AdditionalGuestAmount[]|null
     */
    public function getAdditionalGuestAmount()
    {
        return $this->AdditionalGuestAmount;
    }
    /**
     * This method is responsible for validating the values passed to the setAdditionalGuestAmount method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdditionalGuestAmount method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdditionalGuestAmountForArrayConstraintsFromSetAdditionalGuestAmount(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRateUploadTypeAdditionalGuestAmountAdditionalGuestAmountItem) {
            // validation for constraint: itemType
            if (!$arrayOfRateUploadTypeAdditionalGuestAmountAdditionalGuestAmountItem instanceof \StructType\AdditionalGuestAmount) {
                $invalidValues[] = is_object($arrayOfRateUploadTypeAdditionalGuestAmountAdditionalGuestAmountItem) ? get_class($arrayOfRateUploadTypeAdditionalGuestAmountAdditionalGuestAmountItem) : sprintf('%s(%s)', gettype($arrayOfRateUploadTypeAdditionalGuestAmountAdditionalGuestAmountItem), var_export($arrayOfRateUploadTypeAdditionalGuestAmountAdditionalGuestAmountItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AdditionalGuestAmount property can only contain items of type \StructType\AdditionalGuestAmount, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AdditionalGuestAmount value
     * @throws \InvalidArgumentException
     * @param \StructType\AdditionalGuestAmount[] $additionalGuestAmount
     * @return \ArrayType\ArrayOfRateUploadTypeAdditionalGuestAmount
     */
    public function setAdditionalGuestAmount(array $additionalGuestAmount = array())
    {
        // validation for constraint: array
        if ('' !== ($additionalGuestAmountArrayErrorMessage = self::validateAdditionalGuestAmountForArrayConstraintsFromSetAdditionalGuestAmount($additionalGuestAmount))) {
            throw new \InvalidArgumentException($additionalGuestAmountArrayErrorMessage, __LINE__);
        }
        $this->AdditionalGuestAmount = $additionalGuestAmount;
        return $this;
    }
    /**
     * Add item to AdditionalGuestAmount value
     * @throws \InvalidArgumentException
     * @param \StructType\AdditionalGuestAmount $item
     * @return \ArrayType\ArrayOfRateUploadTypeAdditionalGuestAmount
     */
    public function addToAdditionalGuestAmount(\StructType\AdditionalGuestAmount $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AdditionalGuestAmount) {
            throw new \InvalidArgumentException(sprintf('The AdditionalGuestAmount property can only contain items of type \StructType\AdditionalGuestAmount, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AdditionalGuestAmount[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AdditionalGuestAmount|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AdditionalGuestAmount|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AdditionalGuestAmount|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AdditionalGuestAmount|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AdditionalGuestAmount|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AdditionalGuestAmount
     */
    public function getAttributeName()
    {
        return 'AdditionalGuestAmount';
    }
}
