<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRequiredPaymentsTypeGuaranteePayment ArrayType
 * @subpackage Arrays
 */
class ArrayOfRequiredPaymentsTypeGuaranteePayment extends AbstractStructArrayBase
{
    /**
     * The GuaranteePayment
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\GuaranteePayment[]
     */
    public $GuaranteePayment;
    /**
     * Constructor method for ArrayOfRequiredPaymentsTypeGuaranteePayment
     * @uses ArrayOfRequiredPaymentsTypeGuaranteePayment::setGuaranteePayment()
     * @param \StructType\GuaranteePayment[] $guaranteePayment
     */
    public function __construct(array $guaranteePayment = array())
    {
        $this
            ->setGuaranteePayment($guaranteePayment);
    }
    /**
     * Get GuaranteePayment value
     * @return \StructType\GuaranteePayment[]|null
     */
    public function getGuaranteePayment()
    {
        return $this->GuaranteePayment;
    }
    /**
     * This method is responsible for validating the values passed to the setGuaranteePayment method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGuaranteePayment method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGuaranteePaymentForArrayConstraintsFromSetGuaranteePayment(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRequiredPaymentsTypeGuaranteePaymentGuaranteePaymentItem) {
            // validation for constraint: itemType
            if (!$arrayOfRequiredPaymentsTypeGuaranteePaymentGuaranteePaymentItem instanceof \StructType\GuaranteePayment) {
                $invalidValues[] = is_object($arrayOfRequiredPaymentsTypeGuaranteePaymentGuaranteePaymentItem) ? get_class($arrayOfRequiredPaymentsTypeGuaranteePaymentGuaranteePaymentItem) : sprintf('%s(%s)', gettype($arrayOfRequiredPaymentsTypeGuaranteePaymentGuaranteePaymentItem), var_export($arrayOfRequiredPaymentsTypeGuaranteePaymentGuaranteePaymentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GuaranteePayment property can only contain items of type \StructType\GuaranteePayment, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GuaranteePayment value
     * @throws \InvalidArgumentException
     * @param \StructType\GuaranteePayment[] $guaranteePayment
     * @return \ArrayType\ArrayOfRequiredPaymentsTypeGuaranteePayment
     */
    public function setGuaranteePayment(array $guaranteePayment = array())
    {
        // validation for constraint: array
        if ('' !== ($guaranteePaymentArrayErrorMessage = self::validateGuaranteePaymentForArrayConstraintsFromSetGuaranteePayment($guaranteePayment))) {
            throw new \InvalidArgumentException($guaranteePaymentArrayErrorMessage, __LINE__);
        }
        $this->GuaranteePayment = $guaranteePayment;
        return $this;
    }
    /**
     * Add item to GuaranteePayment value
     * @throws \InvalidArgumentException
     * @param \StructType\GuaranteePayment $item
     * @return \ArrayType\ArrayOfRequiredPaymentsTypeGuaranteePayment
     */
    public function addToGuaranteePayment(\StructType\GuaranteePayment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GuaranteePayment) {
            throw new \InvalidArgumentException(sprintf('The GuaranteePayment property can only contain items of type \StructType\GuaranteePayment, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GuaranteePayment[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GuaranteePayment|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GuaranteePayment|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GuaranteePayment|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GuaranteePayment|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GuaranteePayment|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GuaranteePayment
     */
    public function getAttributeName()
    {
        return 'GuaranteePayment';
    }
}
