<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRoomStayTypeRoomRate ArrayType
 * @subpackage Arrays
 */
class ArrayOfRoomStayTypeRoomRate extends AbstractStructArrayBase
{
    /**
     * The RoomRate
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\RoomRate[]
     */
    public $RoomRate;
    /**
     * Constructor method for ArrayOfRoomStayTypeRoomRate
     * @uses ArrayOfRoomStayTypeRoomRate::setRoomRate()
     * @param \StructType\RoomRate[] $roomRate
     */
    public function __construct(array $roomRate = array())
    {
        $this
            ->setRoomRate($roomRate);
    }
    /**
     * Get RoomRate value
     * @return \StructType\RoomRate[]|null
     */
    public function getRoomRate()
    {
        return $this->RoomRate;
    }
    /**
     * This method is responsible for validating the values passed to the setRoomRate method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRoomRate method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRoomRateForArrayConstraintsFromSetRoomRate(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRoomStayTypeRoomRateRoomRateItem) {
            // validation for constraint: itemType
            if (!$arrayOfRoomStayTypeRoomRateRoomRateItem instanceof \StructType\RoomRate) {
                $invalidValues[] = is_object($arrayOfRoomStayTypeRoomRateRoomRateItem) ? get_class($arrayOfRoomStayTypeRoomRateRoomRateItem) : sprintf('%s(%s)', gettype($arrayOfRoomStayTypeRoomRateRoomRateItem), var_export($arrayOfRoomStayTypeRoomRateRoomRateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RoomRate property can only contain items of type \StructType\RoomRate, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RoomRate value
     * @throws \InvalidArgumentException
     * @param \StructType\RoomRate[] $roomRate
     * @return \ArrayType\ArrayOfRoomStayTypeRoomRate
     */
    public function setRoomRate(array $roomRate = array())
    {
        // validation for constraint: array
        if ('' !== ($roomRateArrayErrorMessage = self::validateRoomRateForArrayConstraintsFromSetRoomRate($roomRate))) {
            throw new \InvalidArgumentException($roomRateArrayErrorMessage, __LINE__);
        }
        $this->RoomRate = $roomRate;
        return $this;
    }
    /**
     * Add item to RoomRate value
     * @throws \InvalidArgumentException
     * @param \StructType\RoomRate $item
     * @return \ArrayType\ArrayOfRoomStayTypeRoomRate
     */
    public function addToRoomRate(\StructType\RoomRate $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RoomRate) {
            throw new \InvalidArgumentException(sprintf('The RoomRate property can only contain items of type \StructType\RoomRate, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RoomRate[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RoomRate|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RoomRate|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RoomRate|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RoomRate|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RoomRate|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RoomRate
     */
    public function getAttributeName()
    {
        return 'RoomRate';
    }
}
