<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfServiceRPHsTypeServiceRPH ArrayType
 * @subpackage Arrays
 */
class ArrayOfServiceRPHsTypeServiceRPH extends AbstractStructArrayBase
{
    /**
     * The ServiceRPH
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ServiceRPH[]
     */
    public $ServiceRPH;
    /**
     * Constructor method for ArrayOfServiceRPHsTypeServiceRPH
     * @uses ArrayOfServiceRPHsTypeServiceRPH::setServiceRPH()
     * @param \StructType\ServiceRPH[] $serviceRPH
     */
    public function __construct(array $serviceRPH = array())
    {
        $this
            ->setServiceRPH($serviceRPH);
    }
    /**
     * Get ServiceRPH value
     * @return \StructType\ServiceRPH[]|null
     */
    public function getServiceRPH()
    {
        return $this->ServiceRPH;
    }
    /**
     * This method is responsible for validating the values passed to the setServiceRPH method
     * This method is willingly generated in order to preserve the one-line inline validation within the setServiceRPH method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateServiceRPHForArrayConstraintsFromSetServiceRPH(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfServiceRPHsTypeServiceRPHServiceRPHItem) {
            // validation for constraint: itemType
            if (!$arrayOfServiceRPHsTypeServiceRPHServiceRPHItem instanceof \StructType\ServiceRPH) {
                $invalidValues[] = is_object($arrayOfServiceRPHsTypeServiceRPHServiceRPHItem) ? get_class($arrayOfServiceRPHsTypeServiceRPHServiceRPHItem) : sprintf('%s(%s)', gettype($arrayOfServiceRPHsTypeServiceRPHServiceRPHItem), var_export($arrayOfServiceRPHsTypeServiceRPHServiceRPHItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ServiceRPH property can only contain items of type \StructType\ServiceRPH, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ServiceRPH value
     * @throws \InvalidArgumentException
     * @param \StructType\ServiceRPH[] $serviceRPH
     * @return \ArrayType\ArrayOfServiceRPHsTypeServiceRPH
     */
    public function setServiceRPH(array $serviceRPH = array())
    {
        // validation for constraint: array
        if ('' !== ($serviceRPHArrayErrorMessage = self::validateServiceRPHForArrayConstraintsFromSetServiceRPH($serviceRPH))) {
            throw new \InvalidArgumentException($serviceRPHArrayErrorMessage, __LINE__);
        }
        $this->ServiceRPH = $serviceRPH;
        return $this;
    }
    /**
     * Add item to ServiceRPH value
     * @throws \InvalidArgumentException
     * @param \StructType\ServiceRPH $item
     * @return \ArrayType\ArrayOfServiceRPHsTypeServiceRPH
     */
    public function addToServiceRPH(\StructType\ServiceRPH $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ServiceRPH) {
            throw new \InvalidArgumentException(sprintf('The ServiceRPH property can only contain items of type \StructType\ServiceRPH, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ServiceRPH[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ServiceRPH|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ServiceRPH|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ServiceRPH|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ServiceRPH|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ServiceRPH|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ServiceRPH
     */
    public function getAttributeName()
    {
        return 'ServiceRPH';
    }
}
