<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RatePlanCrossRefs StructType
 * @subpackage Structs
 */
class RatePlanCrossRefs extends AbstractStructBase
{
    /**
     * The RatePlanCrossRef
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\RatePlanCrossRef[]
     */
    public $RatePlanCrossRef;
    /**
     * Constructor method for RatePlanCrossRefs
     * @uses RatePlanCrossRefs::setRatePlanCrossRef()
     * @param \StructType\RatePlanCrossRef[] $ratePlanCrossRef
     */
    public function __construct(array $ratePlanCrossRef = array())
    {
        $this
            ->setRatePlanCrossRef($ratePlanCrossRef);
    }
    /**
     * Get RatePlanCrossRef value
     * @return \StructType\RatePlanCrossRef[]|null
     */
    public function getRatePlanCrossRef()
    {
        return $this->RatePlanCrossRef;
    }
    /**
     * This method is responsible for validating the values passed to the setRatePlanCrossRef method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRatePlanCrossRef method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRatePlanCrossRefForArrayConstraintsFromSetRatePlanCrossRef(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $ratePlanCrossRefsRatePlanCrossRefItem) {
            // validation for constraint: itemType
            if (!$ratePlanCrossRefsRatePlanCrossRefItem instanceof \StructType\RatePlanCrossRef) {
                $invalidValues[] = is_object($ratePlanCrossRefsRatePlanCrossRefItem) ? get_class($ratePlanCrossRefsRatePlanCrossRefItem) : sprintf('%s(%s)', gettype($ratePlanCrossRefsRatePlanCrossRefItem), var_export($ratePlanCrossRefsRatePlanCrossRefItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RatePlanCrossRef property can only contain items of type \StructType\RatePlanCrossRef, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RatePlanCrossRef value
     * @throws \InvalidArgumentException
     * @param \StructType\RatePlanCrossRef[] $ratePlanCrossRef
     * @return \StructType\RatePlanCrossRefs
     */
    public function setRatePlanCrossRef(array $ratePlanCrossRef = array())
    {
        // validation for constraint: array
        if ('' !== ($ratePlanCrossRefArrayErrorMessage = self::validateRatePlanCrossRefForArrayConstraintsFromSetRatePlanCrossRef($ratePlanCrossRef))) {
            throw new \InvalidArgumentException($ratePlanCrossRefArrayErrorMessage, __LINE__);
        }
        $this->RatePlanCrossRef = $ratePlanCrossRef;
        return $this;
    }
    /**
     * Add item to RatePlanCrossRef value
     * @throws \InvalidArgumentException
     * @param \StructType\RatePlanCrossRef $item
     * @return \StructType\RatePlanCrossRefs
     */
    public function addToRatePlanCrossRef(\StructType\RatePlanCrossRef $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RatePlanCrossRef) {
            throw new \InvalidArgumentException(sprintf('The RatePlanCrossRef property can only contain items of type \StructType\RatePlanCrossRef, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RatePlanCrossRef[] = $item;
        return $this;
    }
}
