<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UniqueID StructType
 * @subpackage Structs
 */
class UniqueID extends UniqueID_Type
{
    /**
     * The PinNumber
     * @var string
     */
    public $PinNumber;
    /**
     * The Reason
     * @var string
     */
    public $Reason;
    /**
     * Constructor method for UniqueID
     * @uses UniqueID::setPinNumber()
     * @uses UniqueID::setReason()
     * @param string $pinNumber
     * @param string $reason
     */
    public function __construct($pinNumber = null, $reason = null)
    {
        $this
            ->setPinNumber($pinNumber)
            ->setReason($reason);
    }
    /**
     * Get PinNumber value
     * @return string|null
     */
    public function getPinNumber()
    {
        return $this->PinNumber;
    }
    /**
     * Set PinNumber value
     * @param string $pinNumber
     * @return \StructType\UniqueID
     */
    public function setPinNumber($pinNumber = null)
    {
        // validation for constraint: string
        if (!is_null($pinNumber) && !is_string($pinNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pinNumber, true), gettype($pinNumber)), __LINE__);
        }
        $this->PinNumber = $pinNumber;
        return $this;
    }
    /**
     * Get Reason value
     * @return string|null
     */
    public function getReason()
    {
        return $this->Reason;
    }
    /**
     * Set Reason value
     * @param string $reason
     * @return \StructType\UniqueID
     */
    public function setReason($reason = null)
    {
        // validation for constraint: string
        if (!is_null($reason) && !is_string($reason)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reason, true), gettype($reason)), __LINE__);
        }
        $this->Reason = $reason;
        return $this;
    }
}
